Program IconView;
{
    (*.ico) Windows  DOS.
  (C)opyright 1993 Aleksei Yatsenko (ᥩ 業)
  Yatsenko%kotek.kiev.ua@ussr.eu.net
  P.O.Box 108 Kiev 252135 Ukraine
  phone (+7 044) 212-0440
  
   㤥 ७ ⥬,  ࠢ쭮 ⠢ 梥  
  (ਢ   ᮮ⢥⢨  ன Windows).
} 

Uses Crt, Graph, bgidriv;

Var
   Icon     : array [0..31, 0..15] of byte;
   IconFile : file of byte;

   stroka   : string[12];
   a,b      : byte;
   Ch       : Char;

   grDriver : Integer;
   grMode   : Integer;
   ErrCode  : Integer;

   Palette  : PaletteType;

Begin
  WriteLn('  ICON VIEWER  v1.0    FREEWARE    (C) 1993 Aleksei Yatsenko ');
  Stroka:= ParamStr(1);
  if Stroka='' then
    begin
      WriteLn;
      WriteLn('   USAGE:  ICONVIEW filename[.ico]');
      WriteLn;
      Halt(2);
    end;
  If Pos('.', Stroka)=0 then Stroka:=Stroka+'.ico';
  Assign(IconFile, Stroka);
  Reset(IconFile);
  Seek(IconFile, $7E);
  For a:= 0 to 31 do
    begin
      For b:= 0 to 15 do
        begin
          Read(IconFile, Icon[a,b]);
        end;
    end;
  If RegisterBGIDriver(@EgaVgaDriverProc)<0 then
  begin
    Writeln('ERROR!');
    Halt(1);
  end;
  grDriver := Detect;
  InitGraph(grDriver, grMode,'');
  ErrCode := GraphResult;
  if ErrCode <> grOk then Writeln('Graphics error:', GraphErrorMsg(ErrCode));

  with Palette do
  begin
    Size := 16;
    Colors[$0] := $0;
    Colors[$1] := $4;
    Colors[$2] := $2;
    Colors[$3] := $3;
    Colors[$4] := $1;
    Colors[$5] := $5;
    Colors[$6] := $6;
    Colors[$7] := $8;
    Colors[$8] := $7;
    Colors[$9] := $c;
    Colors[$a] := $a;
    Colors[$b] := $e;
    Colors[$c] := $9;
    Colors[$d] := $d;
    Colors[$e] := $b;
    Colors[$f] := $3f;
  end;

  SetAllPalette(Palette);
  Rectangle(20,20,270,70);
  Rectangle(20,20,70,70);
  OutTextXY(90,40,Stroka);

  For a:= 0 to 31 do
    begin
      For b:= 0 to 15 do
        begin

          PutPixel(31+b*2, 61-a, Icon[a,b] and $0F);
          PutPixel(30+b*2, 61-a, (Icon[a,b] and $F0) shr 4);


        end;
    end;

  Ch:=ReadKey;
  CloseGraph;
End.